
#include <avr/io.h>
#include <avr/delay.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <D:\home\Dokumenty\VUT\Bakalarka\AVR\IRC-ATmega128\hctl.c>
#include <D:\home\Dokumenty\VUT\Bakalarka\AVR\IRC-ATmega128\lcd.c>



#define setb(port,pin)  port |= 1<<pin    // nastav bit
#define clrb(port,pin)  port &= ~(1<<pin) // nuluj bit
#define negb(port,pin)  port ^= 1<<pin    // neguj bit

//definice hodnot klavesnice
#define VLEVO   0xBF
#define VPRAVO  0x7F
#define NAHORU  0xEF
#define DOLU    0xDF
#define SEDE    0xFD
#define CERVENE 0xFE

volatile unsigned char key_enable = 1; //povoluje(1) nebo zakazuje(0) cteni klaves
char key_pressed = 0; //hodnota zmacknute klavesy
volatile char screen; //cislo zobrazovane obrazovky na displeji
volatile char bufpps[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // texove pole pro vypis cisel na LCD

volatile uint32_t divx = 1 ,divy = 1; //delitele pro preddeleni citanych hodnot
volatile uint32_t pprx = 1 ,ppry = 1; //pulsy za sekundu prednastaveni

volatile uint32_t ppsx[] = {0,0,0,0}; //pole nactenych hodnot pro vypocet rychlosti
volatile uint32_t ppsy[] = {0,0,0,0}; //pole nactenych hodnot pro vypocet rychlosti
volatile uint32_t pps = 0; //pulsy za sekundu
volatile char ab = 0; // index pole nactenych hodnot
volatile double rpsf = 0; // otacky za secundu float

//Ich, presc : kobbinace zapnuti 0=vyp, 1=x, 2=y, 3=xy, pomocne promene stavu rezimu
volatile char freez,radix,mode,usart,presc,ich,negx,negy,send_loop;
// prednastaveni casevace funkci timer3_preset
volatile int TPH; //prednastaveni High
volatile int TPL; //prednastaveni Low
volatile int TP; // rezim spusteni s preddelickou

// promenne ukladane v pameti EEPROM
volatile uint32_t EEMEM eeprom_divx = 660;
volatile uint32_t EEMEM eeprom_divy = 330;
volatile uint32_t EEMEM eeprom_pprx = 660;
volatile uint32_t EEMEM eeprom_ppry = 500;
volatile unsigned char EEMEM eeprom_ich = 1;
volatile char EEMEM eeprom_baud = 4;
volatile int EEMEM eeprom_loop = 25;

// #define F_CPU 11059200UL
 #define F_CPU 12000000UL



// ================================================================
// ===========================  PORTY =============================
// ================================================================

void port_init(void)
{
// hctl DATA
  DDRA  = 0x00;        // vstupni port
  PORTA = 0xFF;        // Zapnu Pull UP

// volny
  DDRB  = 0xFF;  	   // vystupni port
  PORTB = 0x00;        // na nula

//lcd
  DDRC  = 0xFF;        // vystupni port
  PORTC = 0x00;        // vse na 0

//klavesnice  
  DDRD  = 0x00;        // vstupni port
  PORTD = 0xFF;  	   // zapnu Pull UP 

//hctl ovldani I kanalu
  DDRE  = 0B00001100      ;
  PORTE = 0B11111111; 
  
//hctl ovladani
  DDRF  = 0xFF;			// vystupni port
  PORTF = 0x00;  		// vse na 0
  
}
// =================================================================
// =================================================================

// =================================================================
// ===================== EXTRERNAL INTERUPT ========================
// =================================================================
ISR(INT4_vect) //osa y data overflow
{
	if (negy == 0) {negy = 1;} else {negy = 0;};
};

ISR(INT5_vect) //osa x data overflow
{
	if (negx == 0) {negx = 1;} else {negx = 0;};
};

ISR(INT6_vect) //osa y I
{
		if ((ich == 2) || (ich == 3))
		{
			negy = 0;
		};
};

ISR(INT7_vect) //osa x I
{

	if ((ich == 1) || (ich == 3))
		{
			negx = 0;
		};
};

// =================================================================
// =================================================================


// =================================================================
// =========================== TIMER1 ==============================
// =================================================================
//TIMER1 initialize - prescale:64
// WGM: 0) Normal, TOP=0xFFFF
// desired value: 250mSec
// actual value: 250,000mSec (0,0%)

void timer1_init(void)
{
 TCCR1B = 0x00; //stop

 TCNT1H = 0x6D; //setup
 TCNT1L = 0x84;
 
 //TCNT1H = 0x48; //setup 250ms
 //TCNT1L = 0xE5; 
 OCR1AH = 0xB7;
 OCR1AL = 0x1B;
 OCR1BH = 0xB7;
 OCR1BL = 0x1B;
 ICR1H  = 0xB7;
 ICR1L  = 0x1B;
 TCCR1A = 0x00;

 //TCCR1B = 0x03; //start Timer
}
// =================================================================

void timer1_start() //spusteni casovace 1
{
 
 TCNT1H = 0x6D; //setup
 TCNT1L = 0x84;
 
 //TCNT1H = 0x48; //reload counter high value 250ms
 //TCNT1L = 0xE5; //reload counter low value
 key_enable = 0;
 TCCR1B = 0x03; //start
// lcd_posstr(" ",1,19);
// lcd_posstr("z",1,19);

}
// =================================================================

ISR(TIMER1_OVF_vect) //obsluha preruseni timeru 1 pro kalesnici
{
 //TIMER1 has overflowed
 TCNT1H = 0x48; //reload counter high value
 TCNT1L = 0xE5; //reload counter low value
 TCCR1B = 0x00; //stop
 //lcd_posstr(" ",1,19);
 //lcd_posstr("k",1,19);

 key_enable = 1; // povoleni cteni klaves
}
// =================================================================
// =================================================================

// =================================================================
// =========================== TIMER3 ==============================
// =================================================================
void timer3_init(void) // inicializace casovace 3
{
 TCCR3B = 0x00; //stop
 OCR3AH = 0xB7;
 OCR3AL = 0x1B;
 OCR3BH = 0xB7;
 OCR3BL = 0x1B;
 OCR3CH = 0xB7;
 OCR3CL = 0x1B;
 ICR3H  = 0xB7;
 ICR3L  = 0x1B;
 TCCR3A = 0x00;
}

void timer3_start(p) // spusteni casovace 3 s hodnotou preddelicky
{
	TCCR3B = p; //start Timer
}

void timer3_stop()
{
	TCCR3B = 0x00; //stop Timer
}

int timer3_preset(double t) // vypocet prednastaveni pro timer 3; vraci prednastaveni a uklada jej do TPH,TL a TP
{
double preset;
double fpresc;
	
	TP = 0x1;
	if (t >= 0) {fpresc = 8; TP = 0x02; }
	if (t >= 45) {fpresc = 64; TP = 0x03; }
	if (t >= 350) {fpresc = 256; TP = 0x04; }
	if (t >= 1500) {fpresc = 1024; TP = 0x05; }	

	preset = (0xffff-(t/((float)1/((float)12000/fpresc)))+1);

	TCNT3H = (int)preset>>8; //reload counter high value
 	TCNT3L = (int)preset;  //reload counter low value
	TPH = (int)preset>>8; //reload counter high value
 	TPL = (int)preset;  //reload counter low value
	return (int)preset;
 
}

// =================================================================

ISR(TIMER3_OVF_vect) //obsluha preruseni timeru 3
{

		TCNT3H = TPH; 
 		TCNT3L = TPL;
 
 
if (send_loop == 0) 
{
 // send_loop == 0 obsluha pro rezim mereni rychlosti (velocity)
 ppsx[ab] = hctl_read32(0); //nacteni hodnot do pole 
 ppsy[ab] = hctl_read32(1);


 if (ab == 0) 
 	{
		ab=1; // nacetla se prni hodnota, a po dalsim volani se nactedruha
	}
	else
  	{
			ab=0; // byli nacteny obe hodnoty; provede se vypocet rychlosti

			hctl_reset(2);
      _delay_us(25);
		
			// vypocet pro osu X
			lcd_posstr("                    ",3,0);
			if (ppsx[0] >= ppsx[1]) {ppsx[2]=ppsx[0]-ppsx[1];};
			if (ppsx[0] <= ppsx[1]) {ppsx[2]=ppsx[1]-ppsx[0];};

			ultoa((ppsx[2]*5),bufpps,10);
			lcd_posstr(bufpps,2,0);

			rpsf = 5*((double)ppsx[2] / (double)pprx);
			dtostrf(rpsf,7,2,bufpps);
			lcd_posstr(bufpps,2,12);
			

			// vypocet pro osu Y	
			lcd_posstr("                    ",3,0);
 			if (ppsy[0] >= ppsy[1]) {ppsy[2]=ppsy[0]-ppsy[1];};
			if (ppsy[0] <= ppsy[1]) {ppsy[2]=ppsy[1]-ppsy[0];};

			ultoa((ppsy[2]*5),bufpps,10);
			lcd_posstr(bufpps,3,0);

			rpsf = 5*((double)ppsy[2] / (double)ppry);
			dtostrf(rpsf,7,2,bufpps);
			lcd_posstr(bufpps,3,12);
			
		  
		};
} else 
	{
   // send_loop == 1 obsluha pro rezim posilani na rs232
	 	ppsx[0] = hctl_read32(0);
 		ppsy[0] = hctl_read32(1);

		ultoa(ppsx[0],bufpps,10);
		usart_transmit_data8(88);
		usart_transmit_string(bufpps);
		usart_transmit_data8(13);

		ultoa(ppsy[0],bufpps,10);
		usart_transmit_data8(89);
		usart_transmit_string(bufpps);
		usart_transmit_data8(13);
	}

}

// =================================================================
// =================================================================

// =================================================================
// =========================== USART ===============================
// =================================================================
void uart1_init(void) // inicializace radice USART
{
UCSR1B=0x00;  //zastavit nez se nastavi baudrate;
UCSR1A=0x00;
UCSR1C=0x26; // 8bitu 1stopbit Suda parita
UBRR1H=0x00;
UBRR1L=0x4D;
UCSR1B=0x08;

}
// =================================================================

void usart_transmit_data8(char data) //posle bajt po seriove lince
{
  // Wait for empty transmit buffer
  while ( !( UCSR1A & (1<<UDRE1)) )
  ;
  // Put data into buffer, sends the data
  UDR1 = data;
}
// =================================================================
void usart_transmit_string(const char* data) // posle retezec po seriove lince
{
  while (*data !='\0')
  {
    // Wait for empty transmit buffer
    while ( !( UCSR1A & (1<<UDRE1)) );
	// Put data into buffer, sends the data
    UDR1 = *data;
	_delay_ms(2);
	data +=1;

  }
}
// =================================================================
// rozebere cisla na cislice a odesila zvlast (do peti cifer)
void usart_transmit_numbers(unsigned int data) 
{
  uint_fast32_t pom1; 					// pomocna promenna
  uint_fast32_t pom2; 					// pomocna promenna
  unsigned int i; 						// pomocna promenna

  i = 10000;							// posln pticifernho sla
  pom1 = data;
  while (i > 0) { 						// rozebrani cisla na cislice
    pom2 = pom1 / i; 					// zsk slici danho du
    if (pom2 > 0) {
      pom1 = pom1 - ( pom2 * i); 		// umazn nejvy slice z celkovho sla
    }
    usart_transmit_data8(pom2 + 48); 	// slice peveden do ASCII kdu
    i = i/10;
  }
}

// =================================================================
// =================================================================



// =================================================================
// ================= KLAVESNICE ====================================
// =================================================================

char keyboard(void) // cteni stisku klavesy
{
char key;
key = 0;
if (key_enable == 1) // jestli je povoleno cist klavesy, cti
	{
	key = PIND; 
	_delay_us(1);
	key = PIND;
	key = (key & 0B11110011) | 0B000001100; //vymaskovani pouze pripojenych tlacitek na portu
	key_pressed = key;
/*
	if (key == 0x7F) { lcd_posstr("       ",1,6); lcd_posstr("vpravo",1,6);}
	if (key == 0xBF) { lcd_posstr("       ",1,6); lcd_posstr("vlevo",1,6); }
	if (key == 0xDF) { lcd_posstr("       ",1,6); lcd_posstr("dolu",1,6);  }
	if (key == 0xEF) { lcd_posstr("       ",1,6); lcd_posstr("nahoru",1,6);}
	if (key == 0xFB) { lcd_posstr("       ",1,6); lcd_posstr("stop",1,6);  }
	if (key == 0xF7) { lcd_posstr("       ",1,6); lcd_posstr("start",1,6); }
*/
    if (key != 0xFF) timer1_start(); // stusti odmerovani casu po ktery je cteni zakazano

	}
	return key; // vrati prectehou klavesu


}
// =================================================================
// =================================================================



// =================================================================
// ================== MENU =========================================
// =================================================================


// =====================  MENU - COUNTER ===========================

char counter(void) // rezim citani
{
volatile uint32_t data_1, data_2, data_3, data_4;
char k; // klavesa
unsigned char d[]={0,0,0,0,0,0,0,0,0,0,0};
unsigned char du[]={0,0,0,0,0,0,0,0,0,0,0};
volatile uint32_t posx,posy,px,py,maxx,maxy;
volatile char buf[]={0,0,0,0,0,0,0,0,0,0,0};
unsigned char vlevo_toggle = 0, dir = 0;

//***  inicialiyace promnenzch a vykresleni obrazovky
  lcd_clr();
  lcd_cursoroff();
  lcd_posstr("IRCx:",2,0);
  lcd_posstr("IRCy:",3,0);
  posx=0ul; posy=0ul; px=0ul; py=0ul;
  maxx=0; maxy=0;
  data_1=0; data_2=0; data_3=0; data_4=0;
  divx = eeprom_read_dword(&eeprom_divx); //hodnota preddelicky x
  divy = eeprom_read_dword(&eeprom_divy); //hodnota preddelicky y
  ich = 0; //eeprom_read_byte(&eeprom_ich);
  hctl_ichanels(ich);
  switch (ich)
							{
								case 0: //vypni xy
									{			
										lcd_posstr("   ",0,13);
									}
								break;
					
								case 1: //zapni x
									{
										lcd_posstr("Ix ",0,13);
									}
								break;

								case 2: //zapni y
									{
										lcd_posstr("I y",0,13);
									}
								break;

								case 3: //zapni xy
									{	
										lcd_posstr("Ixy",0,13);
									}
								break;
								default:{};
							}
  

  if (freez == 1) {lcd_posstr("Freezed    ",0,0);} else {lcd_posstr("progress...",0,0);};
    
  if (radix == 10) {lcd_posstr("dec",1,6);} else {lcd_posstr("hex",1,16);};

  switch (mode)
    {
	case 1: {lcd_posstr("1x",1,0);}
	break;
	case 2: {lcd_posstr("2x",1,0);}
	break;
	case 4: {lcd_posstr("4x",1,0);}
	break;
	default:{};
    }

  if (usart == 1) {lcd_posstr("USART",1,15);};
  
  //if (divx != 1) { lcd_posstr("D",0,17); lcd_posstr("x",0,18); presc=1;} else{};
  //if (divy != 1) { lcd_posstr("D",0,17); lcd_posstr("y",0,19); presc=presc+2;} else{};
  hctl_decmode(mode);
  k = 0;

// hlavni smycka citani
// -------------------------------- SMYCKA ------------------------------------
while (k !=0xDDu ) // podminka je naplnena pri stisku navratove klavesy VLEVO
{ 
  
  //--- KLAVESY ---------------------------------------------------------------
  switch (k = keyboard())
	 {
	 	//--- SEDE ------------------------------------------------------------
	 	case SEDE:
		{		 
		      if (freez==0) {freez=1; lcd_posstr("Freezed    ",0,0);}
			    else {
						freez=0; 
						lcd_posstr("progress...",0,0);
						lcd_posstr("IRCx:              ",2,0);
						lcd_posstr("IRCy:              ",3,0);
						}
		}	    
		break; 
		// --------------------------------------------------------------------


		//--- CERVENE ---------------------------------------------------------
		case CERVENE:
		{
		    if (freez==0) 
			  {
			  	hctl_reset(2);
			  	negx = 0;
			  	negy = 0;
			  }
			  if ((freez==1) && (vlevo_toggle==1)) 
			  	{
					lcd_posstr("IRCx:              ",2,0);
					lcd_posstr("IRCy:              ",3,0);
					maxx=0;
					maxy=0;
					vlevo_toggle==0;
				}
		}
		break; 
		// ---------------------------------------------------------------------



		//--- VPRAVO -----------------------------------------------------------
   		case VPRAVO:
		{
			   if (radix==10) 
			     {
				    radix=16; 
				    lcd_posstr("hex",1,6);
				    if (freez==1)
				      {
				        ultoa(px,d,radix);
				        lcd_posstr(d,2,6);
				        ultoa(py,d,radix);
				        lcd_posstr(d,3,6);
				      } 
               else {px=0;py=0;}
				  			   
			     } else 
			         { 
			           radix=10; 
				         lcd_posstr("dec",1,6);
				         if (freez==1)
				            {
				              ultoa(px,d,radix);
				              lcd_posstr(d,2,6);
					          ultoa(py,d,radix);
				              lcd_posstr(d,3,6);
				            }
				            else {px=0;py=0;};
				        }
		}
    	break;
		// ---------------------------------------------------------------------


		//--- VLEVO -----------------------------------------------------------
   		case VLEVO:
		{
			if (freez==1)
			{
			if ((ich==1) || (ich==3))
				{
					if (vlevo_toggle ==0) 
					{
						lcd_posstr("MAXx:             ",2,0);
						ultoa(maxx,d,radix);
						lcd_posstr(d,2,6);
						
					}else
						{
							lcd_posstr("IRCx:             ",2,0);
							ultoa(px,d,radix);
							lcd_posstr(d,2,6);
						};

				};

				if ((ich==2) || (ich==3))
				{
					if (vlevo_toggle ==0) 
					{
						lcd_posstr("MAXy:             ",3,0);
						ultoa(maxy,d,radix);
						lcd_posstr(d,3,6);
						
					}else
						{
							lcd_posstr("IRCy:             ",3,0);
							ultoa(py,d,radix);
							lcd_posstr(d,3,6);
						};

				};

			if (vlevo_toggle==0) {vlevo_toggle=1;} else {vlevo_toggle=0;}

			}
			else k = 0xDDu;
		}
		break;
		// ---------------------------------------------------------------------

		//--- NAHORU -----------------------------------------------------------
		case NAHORU:
		{
			if (freez==1)
				{
		    		if (usart==0) { usart=1; lcd_posstr("USART",1,15);}
					else
		    		if (usart==1) { usart=0; lcd_posstr("     ",1,15);}
			
				} 
				else {
						switch (presc)
							{
								case 0: //vypnuta = zapni x
									{	
												
										if (divx != 1) {lcd_posstr("Dx ",0,17); presc=1;} 
										else
										if (divy != 1) {lcd_posstr("D y",0,17); presc=2;}
										else{lcd_posstr("   ",0,17); presc=0;};
  									}
								break;
					
								case 1: //presc x = zapni y
									{
										if (divy != 1) {lcd_posstr("D y",0,17); presc=2;} 
										else{lcd_posstr("   ",0,17); presc=0;};	
									}
								break;

								case 2: //presc y = zapni xy
									{
										if (divx != 1) {lcd_posstr("Dxy",0,17); presc=3;} 
										else{lcd_posstr("   ",0,17); presc=0;};	
									}
								break;

								case 3: //presc xy = vypni
									{			
										lcd_posstr("   ",0,17); presc=0;	
									}
								break;
								default:{};
							}
						
					
			 		}

		}
		break;
		// ---------------------------------------------------------------------


		//--- DOLU -------------------------------------------------------------
		case DOLU: 
			{
				if (freez==0)
					{
		    			if (mode==1) { mode=2; lcd_posstr("2x",1,0); hctl_decmode(2); }
						else
		    			if (mode==2) { mode=4; lcd_posstr("4x",1,0); hctl_decmode(4);}
						else
						if (mode==4) { mode=1; lcd_posstr("1x",1,0); hctl_decmode(1);}
						else{};
				
					};
				if (freez==1)
					{
						switch (ich)
							{
								case 0: //vypnuta = zapni x
									{			
										clrb(HCTL_IPORT,ICHX);
										setb(HCTL_IPORT,ICHY);
										ich = 1; 
										lcd_posstr("Ix ",0,13);

									}
								break;
					
								case 1: //ich x = zapni y
									{
										setb(HCTL_IPORT,ICHX);
										clrb(HCTL_IPORT,ICHY);
										ich = 2;
										lcd_posstr("I y",0,13);
	
									}
								break;

								case 2: //ich y = zapni xy
									{
										clrb(HCTL_IPORT,ICHX);
										clrb(HCTL_IPORT,ICHY);
										ich = 3;
										lcd_posstr("Ixy",0,13);										

									}
								break;

								case 3: //ich xy = vypni
									{	
										setb(HCTL_IPORT,ICHX);
										setb(HCTL_IPORT,ICHY);
										ich = 0;		
										lcd_posstr("   ",0,13); presc=0;	
									}
								break;
								default:{};
							}
						
					}
			}
		break;
		// ---------------------------------------------------------------------
 
		default: {}
	 }
	 //--- END KLAVESY ---------------------------------------------------------------
      

	 // --- ZOBRAZOVANI -----------------------------------------------------------------
	 if (freez==0 || usart==1) //cteni z dekoderu
	 	{
		  posx = hctl_read32(0); 
		  	if (negx == 1) {posx = (uint32_t)0xFFFFFFFFUL - (uint32_t)posx;};

		  posy = hctl_read32(1);
		  	if (negy == 1) {posy = (uint32_t)0xFFFFFFFFUL - (uint32_t)posy;};
		
		// indikace preteceni registru dekoderu
		 if (negx == 1)  { lcd_posstr("-",2,5);}
		 if (negx == 0)  lcd_posstr("+",2,5);
		  
	 	 if (negy == 1)  lcd_posstr("-",3,5);
		 if (negy == 0)  lcd_posstr("+",3,5);

		  if ((ich == 1) || (ich==3)) // rezimi zapnutych I kanalu
		  	{
		  		if (posx>maxx) maxx = posx;
				if (maxx != 0) lcd_posstr("M",2,18);
			}else{};
		  
		  if ((ich == 2) || (ich==3))
		  	{
		  		if (posy>maxy) maxy = posy;
				if (maxy != 0) lcd_posstr("M",3,18);
			}else{};
		  

          if (freez==0) // zobrazovani smeru otaceni
				{
									
						if ((posx > px) && (negx == 0))  {lcd_posstr("R",2,19); dir = 2;}
		  				if ((posx < px) && (negx == 0))  {lcd_posstr("L",2,19); dir = 1;} 

						if ((posx > px) && (negx == 1))  {lcd_posstr("L",2,19); dir = 1;}
		  				if ((posx < px) && (negx == 1))  {lcd_posstr("R",2,19); dir = 2;}

						if (posx == px) lcd_posstr("-",2,19);

				

		  				if ((posy > py)  && (negy == 0))  {lcd_posstr("R",3,19); dir = 2;}
		  				if ((posy < py)  && (negy == 0))  {lcd_posstr("L",3,19); dir = 1;}

						if ((posy > py)  && (negy == 1))  {lcd_posstr("L",3,19); dir = 1;}
		  				if ((posy < py)  && (negy == 1))  {lcd_posstr("R",3,19); dir = 2;}

		  				if (posy == py) {lcd_posstr("-",3,19); dir = 0;}
						
             	}

	


	 	  if (posx != px) // jestli se citana hodnota zmenila, zobrazuj
	 	  	{
			
				px = posx;
				if ((presc == 1) || (presc == 3)) {px = px / divx;} else{}; // preddelicka
						ultoa(px,d,radix);
	 			if (freez == 0) 
					{
						lcd_posstr("           ",2,6);
						lcd_posstr(d,2,6);
					};
				if (usart==1) // posilani na seriovku
					{
						if (dir == 2) usart_transmit_data8(82);
						if (dir == 1) usart_transmit_data8(76);
						if (negx == 0) usart_transmit_data8(43);
		  				if (negx == 1) usart_transmit_data8(45);
						usart_transmit_string(d);
						usart_transmit_data8(13);
				};
				px = posx;
			} else{};
	 
	 	 	  
	 	  if (posy != py)
		  	{
		  		py = posy;
				if ((presc == 2) || (presc == 3)) {py = py / divy;} else{}; // preddelicka
	 		   		ultoa(py,d,radix);
            	if (freez == 0) 
					{
						lcd_posstr("           ",3,6);
						lcd_posstr(d,3,6);
					};
				if (usart==1) 
					{
						if (dir == 2) usart_transmit_data8(82);
						if (dir == 1) usart_transmit_data8(76);
						if (negy == 0) usart_transmit_data8(43);
		  				if (negy == 1) usart_transmit_data8(45);
						usart_transmit_string(d);
						usart_transmit_data8(13);
					}; 
				py = posy;
			}
		}
		// --- END ZOBRAZOVANI ------------------------------------------------------------
}
// --- END SMYCKA -----------------------------------------------------------------
 return 0;
	 
}
// =================================================================




//==================== INIT SCREEN ============================
void init_screen(void) //inicializacni obrazovka
{
  char i;

  lcd_posstr("  BAKALARSKA PRACE  ",0,0);
  lcd_posstr("    IRC Dekoder     ",1,0);
  lcd_posstr("Martin Pavlacek 3P31",2,0);
  i=0;
  while(i!=19)
  {
    lcd_posstr(".",3,i);
	_delay_ms(150);
	i++;
  }
  lcd_clr();
}
// =================================================================

//========================= MAIN MENU ============================
char menu(void) // zobrazuje hlavni menu a pohyb v nem pomoci klaves; vlaci hodnotu zvolene polozky menu
{
char k,row,m,sub_menu;

  lcd_clr();
  lcd_cursoron(1);
  lcd_posstr("MENU:",0,0);
  lcd_posstr("1/2",0,16);

  lcd_posstr("Counter",1,0);
  lcd_posstr("Tachometr",2,0);
  lcd_posstr("RS232 sending loop",3,0);
  //lcd_posstr("Settings",3,0);
  
	

  row = 1;
  sub_menu = 1;
  m=0;
  k=0;
  lcd_goto(row,0);

  while (k !=0xDDu) // cteni klaves a prochazeni menu
  {
    switch(k = keyboard())
		{
			case DOLU://--- DOLU ------------
				{
					if (sub_menu == 1)
					{
	   					if (row==3)	
							{ 
								row = 1;
								sub_menu++;
								lcd_clr();
  								lcd_posstr("MENU:",0,0);
  								lcd_posstr("2/2",0,16);
								lcd_posstr("Settings",1,0);
							} else row++;
		
					} else 
						{   
							if (row==1)
								{
						   			row = 1;
						   			sub_menu = 1;
									lcd_clr();
  									lcd_posstr("MENU:",0,0);
  									lcd_posstr("1/2",0,16);
									lcd_posstr("Counter",1,0);
  									lcd_posstr("Tachometr",2,0);
  									lcd_posstr("RS232 sending loop",3,0);
								}else row++;

						};
					

	   				lcd_goto(row,0);
				}
			break;
			// ---------------------------------
			case NAHORU://--- NAHORU ------------
				{

					if (sub_menu == 1)
					{
	   					if (row==1)	
							{ 
								row = 1;
								sub_menu++;
								lcd_clr();
  								lcd_posstr("MENU:",0,0);
  								lcd_posstr("2/2",0,16);
								lcd_posstr("Settings",1,0);
							} else row--;
		
					} else 
						{
							if (row==1)
								{
								   	row = 3;
						   			sub_menu = 1;
									lcd_clr();
  									lcd_posstr("MENU:",0,0);
  									lcd_posstr("1/2",0,16);
									lcd_posstr("Counter",1,0);
  									lcd_posstr("Tachometr",2,0);
  									lcd_posstr("RS232 sending loop",3,0);
								} else row--;
						};
					

	   				lcd_goto(row,0);
				}
			break;
			// ---------------------------------
			case VPRAVO://--- VPRAVO ------------
				{
					if ((row==1) && (sub_menu == 1)) m=1; 
	  				if ((row==2) && (sub_menu == 1)) m=2; 
	  				if ((row==3) && (sub_menu == 1)) m=3; 
					if ((row==1) && (sub_menu == 2)) m=4; 
	  				k=0xDDu;
				}
    		break;
			// ---------------------------------
			default: {}
	}

  }
  return m;

}
// =================================================================



//======================= MENU - SETTINGS ==========================
char settings(void) // menu nastveni; vraci hodnotu zvoleneho menu
{
char k,row,m;

  lcd_clr();
  lcd_cursoron(1);
  lcd_posstr("SETTINGS:",0,0);
  lcd_posstr("Prescale",1,0);
  lcd_posstr("Tachometr",2,0);
  lcd_posstr("Usart",3,0);
  
  row = 1;
  m=0;
  lcd_goto(row,0);
  k=0;

  while (k !=0xDDu)
  {
    switch(k = keyboard())
	{
	case DOLU://--- DOLU ------------
	{
	   if (row==3)
	   { row = 1; } else row++;
	   lcd_goto(row,0);
	}
	break;
	// ---------------------------------
	case NAHORU://--- NAHORU ------------
	{
		if (row==1)
	   { row = 3; } else row--;
	   lcd_goto(row,0);
	}
	break;
	// ---------------------------------
	case VLEVO://--- VLEVO ------------
		{
		  m=0;
		  k=0xDDu;
		}
    break;
	// ---------------------------------
	case VPRAVO://--- VPRAVO ------------
	{
	  if (row==1) m=31; 
	  if (row==2) m=32; 
	  if (row==3) m=33; 
	  k=0xDDu;
	}		
	break;
	// ---------------------------------
	default: {}
	}

  }
  return m;

}
// =================================================================


//================== MENU - SETTINGS - PRESCALE ====================
char prescale(char set) // menu pro nastaveni hodnot preddelicky a ulozeni do eeprom
{
volatile int k,m,i,j;
unsigned char dx[]={0,0,0,0,0,0,0,0,0,0,0};
unsigned char dy[]={0,0,0,0,0,0,0,0,0,0,0};
volatile uint32_t idx,idy, ipprx,ippry;
volatile unsigned char num;

  lcd_clr();
  lcd_cursoron(0);
  if (set == 0) //prescale settings
  	{
		lcd_posstr("PRESCALE:",0,0);
  		lcd_posstr("divx:",1,0);
  		lcd_posstr("divy:",2,0);
    

  		divx = eeprom_read_dword(&eeprom_divx); //hodnota preddelicky x
  		divy = eeprom_read_dword(&eeprom_divy); //hodnota preddelicky y

  		ultoa(divx,dx,10);
  		lcd_posstr(dx,1,6);
  		ultoa(divy,dy,10);
  		lcd_posstr(dy,2,6);
		idx = 0; idy = 0;

	}
	
   if (set == 1) //tachometr settings
  	{
		lcd_posstr("PULSE PER ROTATION",0,0);
  		lcd_posstr("pprx:",1,0);
  		lcd_posstr("ppry:",2,0);
    

  		pprx = eeprom_read_dword(&eeprom_pprx); //hodnota preddelicky x
  		ppry = eeprom_read_dword(&eeprom_ppry); //hodnota preddelicky y

  		ultoa(pprx,dx,10);
  		lcd_posstr(dx,1,6);
  		ultoa(ppry,dy,10);
  		lcd_posstr(dy,2,6);
		ipprx = 0; ippry = 0;

	}

   
    
  k=0;m=0;
  num = 0;
  i=1; j=6;
  

  lcd_goto(i,j);
  k = NAHORU;
  while (k !=0xDDu)
  {
  	
    switch(k = keyboard())
		{
			case NAHORU: //--- NAHORU --------------
	 			{
					if (num == 9) {num = 0;} else {num++;}
					lcd_goto(i,j);
					lcd_data(num + 48);
					lcd_goto(i,j);
					
					if (i==1) {dx[j-6] = (num + 48);} else {};
					if (i==2) {dy[j-6] = (num + 48);} else {};
				
					
										
				}
			break; //--------------------------

			case DOLU: //--- DOLU --------------
				{
	   				if (num == 0) {num = 9;} else {num--;}
					lcd_goto(i,j);
					lcd_data(num + 48);
					lcd_goto(i,j);
					
					if (i==1) {dx[j-6] = (num + 48);} else{};
					if (i==2) {dy[j-6] = (num + 48);} else{};			
				}
			break; //--------------------------

		
			case VPRAVO: //--- VPRAVO --------------
				{
				    if (j == 15) {j = 6;} else {j++;}
					lcd_goto(i,j);
					num = 0;
						
			
				}
    		break; //--------------------------


			case VLEVO://--- VLEVO --------------
				{
		  			if (j == 6) {j = 15;} else {j--;}
					lcd_goto(i,j);
					num = 0;
				}
    		break; //--------------------------

	
			case SEDE: //--- SEDE --------------
				{
					if (i == 1) 
						{
							i++; 
							j=6; 
							lcd_goto(i,j);
						} else
	  			    if (i == 2) 
						{
							
							lcd_posstr("Save it?",3,0);

							if (set == 0)
								{
									idx = atol(dx);
						    		idy = atol(dy);

									if (idx == 0) {idx = 1;} else{};
									if (idy == 0) {idy = 1;} else{};
													
									ultoa(idx,dx,10);
	 		                		lcd_posstr(dx,1,6);

									ultoa(idy,dy,10);
	 		                		lcd_posstr(dy,2,6);

									i++;
									lcd_goto(3,19);
								}

							if (set == 1)
								{
									ipprx = atol(dx);
						    		ippry = atol(dy);

									if (ipprx == 0) {ipprx = 1;} else{};
									if (ippry == 0) {ippry = 1;} else{};
													
									ultoa(ipprx,dx,10);
	 		                		lcd_posstr(dx,1,6);

									ultoa(ippry,dy,10);
	 		                		lcd_posstr(dy,2,6);

									i++;
									lcd_goto(3,19);
								}

						} else
					if (i == 3)
						{
							lcd_posstr("Saved!             ",3,0);
							if (set == 0)
								{
									divx = idx;
									divy = idy;
							
									eeprom_write_dword(&eeprom_divx,idx);
									eeprom_write_dword(&eeprom_divy,idy);
								}
							if (set == 1)
								{
									pprx = ipprx;
									ppry = ippry;
							
									eeprom_write_dword(&eeprom_pprx,ipprx);
									eeprom_write_dword(&eeprom_ppry,ippry);
								}


							_delay_ms(700);
							k=0xDDu;
							m=4;
						}

									            
				 }		
			break; //--------------------------


			case CERVENE: //--- CERVENE --------------
				{
	  				
					if (i==1)
						{
							lcd_posstr("              ",i,6);
							j=6;
							ultoa(1,dx,10);
							lcd_posstr(dx,i,6);
							lcd_goto(i,j);
							num=0;
						}
					if (i==2)
						{
							lcd_posstr("              ",i,6);
							j=6;
							ultoa(1,dy,10);
							lcd_posstr(dx,i,6);
							lcd_goto(i,j);
							num=0;
						}	 
	  				if (i==3)
						{
							//i=1;
							//j=6;
							//lcd_posstr("          ",3,0);
							//lcd_goto(i,j);
							//num=0;
							lcd_posstr("Don't Saved!       ",3,0);
							_delay_ms(700);
							k=0xDDu;
							m=4;

						}
	  			}		
			break; //--------------------------

	default: {}
	}

  }
  return m;

}
// =================================================================

//================== MENU - VELOCITY ====================
char velocity() // rezim mereni rzchlosti;
{
	char k;
	int time = 200;
	// vykrelseni na obrazovce a nastaveni promenych
	lcd_clr();
	lcd_cursoroff(0);
  	lcd_posstr("VELOCITY:",0,0);
	lcd_posstr("[pps]",1,0);
	lcd_posstr("[rps]",1,14);
	  pprx = eeprom_read_dword(&eeprom_pprx); //pusu za sekundu tachometru x
  	ppry = eeprom_read_dword(&eeprom_ppry); //pusu za sekundu tachometru x

	hctl_ichanels(0); // vypne i kanaly na obou osach
	hctl_decmode(1); // rezim citani 1x 
	hctl_reset(2); // reset registru citace

	send_loop = 0; // nastaveni pro obsluhu preruseni pro mereni rychlosti
	timer3_stop();
	timer3_init(); // inicializace casovace
	timer3_preset(time); // vypocitani prednastaveni pro casovac
	timer3_start(TP); // spusteni casovace s prerusenim s merenim rychlosti;
	

   	while (k !=VLEVO) // pouze cte klavesy dokola doku VLEVO
   		{
    		k = keyboard();
		};

	timer3_stop(); //stop zastavy casovac
	return 0; // navratova hodnota hlavniho menu
}
// ================== nastaveni baudove rychlosti pro USART =====
char * usart_baudrate(char b) // nastavuje rychlost komunikace na zaklade promene b; vraci smernik na textovy reteyec s nastavenou rzchlosti, pou6iva se pro vzpis na displej
{
	UCSR1B=0x00; //zastav USART
	switch (b)
	{
		case 0:	//600 0
		{
			UBRR0L = 0xE1; //set baud rate lo
			UBRR0H = 0x04; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "660 (0%)";
		};
		break;

		case 1:		//1200 0
		{
 			UBRR0L = 0x70; //set baud rate lo
 			UBRR0H = 0x02; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "1200 (0%)";
		}
		break;

		case 2:		//2400 0,2
		{
 			UBRR0L = 0x38; //set baud rate lo
 			UBRR0H = 0x01; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "2400 (0,2%)";
		};
		break;

		case 3:		//4800 0,2
		{
 			UBRR0L = 0x9B; //set baud rate lo
 			UBRR0H = 0x00; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "4800 (0,2%)";
		}
		break;

		case 4:		//9600 0,2
		{
 			UBRR0L = 0x4D; //set baud rate lo
 			UBRR0H = 0x00; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "9600 (0,2%)";
		}
		break;

		case 5:		//14400 0,2
		{
 			UBRR0L = 0x33; //set baud rate lo
 			UBRR0H = 0x00; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "14400 (0,2%)";
		}
		break;

		case 6:		//19200 0,2
		{
 			UBRR0L = 0x26; //set baud rate lo
 			UBRR0H = 0x00; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "19200 (0,2%)";
		}
		break;

		case 7:		//28800 0,2
		{
 			UBRR0L = 0x19; //set baud rate lo
 			UBRR0H = 0x00; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "28800 (0,2%)";
		};
		break;

		case 8:		//115200 7,5
		{
 			UBRR0L = 0x06; //set baud rate lo
 			UBRR0H = 0x00; //set baud rate hi
			UCSR1B=0x08; //zapni USART;
			return "115200 (7,5%)";
		}
		break;
	}
	UCSR1B=0x08; //zapni USART;
}


// ========================MENU - SETTINGS - USART -====================
char usart_settings() //menu pro nastaveni seriove komunikace
{
	char k,row;
	char baud,baud_old;
	int time,time_old;
	char buf[]={0,0,0,0,0,0,0,0,0,0,0,0,0};

	//char buf[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	lcd_clr();
	lcd_cursoron(0);
  	lcd_posstr("USART:",0,0);
	lcd_posstr("Baud :",1,0);
	lcd_posstr("Loop :",2,0);
	
	baud = eeprom_read_byte(&eeprom_baud);
	baud_old=baud;
	
	time = eeprom_read_word(&eeprom_loop);
	time_old = time;

	lcd_posstr("    ms        ",2,6);
	itoa(time,buf,10);
	lcd_posstr(buf,2,6);
	itoa(timer3_preset(time),buf,16);
	lcd_posstr(buf,2,16);

	row = 1;
	k=0;

	lcd_posstr(usart_baudrate(baud),1,6);
	lcd_goto(1,6);
	time = eeprom_read_dword(&eeprom_loop);
	timer3_preset(time);


	
	while (k !=0xDDu)
   	{
    	switch (k = keyboard())
		{
			case NAHORU:
			{
				if (row == 1)
				{
					if (baud == 8) {baud=0;}
					else {baud++;};
					lcd_posstr("              ",1,6);
					lcd_posstr(usart_baudrate(baud),1,6);
					lcd_goto(1,6);
				};

				if (row == 2)
				{
					
					if (time == 5000) time = 10;
						else time = time + 5;

					lcd_posstr("    ms        ",2,6);
					itoa(time,buf,10);
					lcd_posstr(buf,2,6);

					itoa(timer3_preset(time),buf,16);
					lcd_posstr(buf,2,16);

					lcd_goto(2,6);
				};
			}
			break;

			case DOLU:
			{
				if (row == 1)
				{
					if (baud == 0) {baud=8;}
					else {baud--;};
					lcd_posstr("              ",1,6);
					lcd_posstr(usart_baudrate(baud),1,6);
					lcd_goto(1,6);
				}

				if (row == 2)
				{
					
					if (time == 10) time = 5000;
						else time = time - 5;

					lcd_posstr("    ms        ",2,6);
					itoa(time,buf,10);
					lcd_posstr(buf,2,6);

					itoa(timer3_preset(time),buf,16);
					lcd_posstr(buf,2,16);

					lcd_goto(2,6);
				};

			}
			break;

			case SEDE:
			{
				if (row == 1) 
					{
						row++;
						lcd_goto(row,6);
						break;
					}
				if (row == 2)
					{
						lcd_posstr("Save it?           ",3,0);
						row++;
						lcd_cursoroff();
						break;
					};
				if (row == 3)
					{
						eeprom_write_byte(&eeprom_baud,baud);
						eeprom_write_word(&eeprom_loop,time);
						lcd_posstr("Saved!             ",3,0);
						lcd_cursoroff();
						_delay_ms(700);
						k=0xDDu;
						break;	
					};
			}
			break;

			case CERVENE:
			{
				if (row == 3)
					{
						usart_baudrate(baud_old);
						timer3_preset(time_old);
						lcd_posstr("Don't Saved!       ",3,0);
						_delay_ms(700);
						k=0xDDu;
						break;
					}
			}
			break;
		};
	}
			
	return 4;

}

// ===================== rezim posilani na seriovou linku ====================
char R232sending(void)
{
	char k=0,toggle=0;
	int time;
	char buf[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

	time = eeprom_read_word(&eeprom_loop);
	lcd_clr();
	lcd_cursoroff();
	lcd_posstr("RS232:",0,0);
	lcd_posstr("stop",0,6);
	lcd_posstr("Time loop:",1,0);
	lcd_posstr("ms",1,15);
	lcd_posstr("Dec mode:",2,0);
	lcd_posstr("1x",2,9);

	ultoa(time,buf,10);
	lcd_posstr(buf,1,10);

	lcd_goto(3,19);
	
	mode = 1; // rezim citani 1
	hctl_ichanels(0); // vypne I kanaly
	hctl_decmode(mode); //rezim citani 1
	hctl_reset(2); // reset dekoderu
	send_loop = 1; // nastavuje preruseni obsluhu preruseni casovace3 pro rezin odesilani
	timer3_init();
	timer3_preset(time); //vypocteni prednastaveni podle nastavene hodnoty


	while (k !=0xDDu) // smycka cteni klaves
   	{
    	switch (k = keyboard())
		{
			case VLEVO: // navrat do menu
			{
				if (toggle == 0)
				{
					k=0xDDu;
				};
			};
			break;

			case SEDE: //start, stop odesilani
			{
				if (toggle == 0)
					{
						toggle = 1;
						lcd_posstr("          ",0,6);
						lcd_posstr("sending...",0,6);
						lcd_goto(0,16);
						lcd_cursoron(1);
						timer3_preset(time);
						timer3_start(TP);
					} else
						{
							toggle = 0;
							timer3_stop();
							lcd_cursoroff();
							lcd_posstr("          ",0,6);
							lcd_posstr("stop",0,6);
						};
			};
			break;

			case CERVENE: // reset dekoderu
			{
				if (toggle == 0)
					{
						hctl_reset(2);
						lcd_posstr("          ",0,6);
						lcd_posstr("reset",0,6);
						_delay_ms(200);
						lcd_posstr("          ",0,6);
						lcd_posstr("stop",0,6);

					}
			};
			break;

			case VPRAVO: // zmena rezimu citace
			{
				if (toggle == 0)
					{
						hctl_reset(2);
		    			if (mode==1) { mode=2; lcd_posstr("2x",2,9); hctl_decmode(2); }
						else
		    			if (mode==2) { mode=4; lcd_posstr("4x",2,9); hctl_decmode(4);}
						else
						if (mode==4) { mode=1; lcd_posstr("1x",2,9); hctl_decmode(1);}
						else{};
				
					};
			}
			break;

			case NAHORU: // nastaveni intervalu odesilaci smycky o krok nahoru
			{
				if (toggle == 0)
				{
					if (time == 5000) time = 10;
						else time = time + 5;
					lcd_posstr("     ",1,10);
					ultoa(time,buf,10);
					lcd_posstr(buf,1,10);
				}
	

			}
			break;

			case DOLU: // nastaveni intervalu odesilaci smycky o krok dolu
			{
				if (toggle == 0)
				{
					if (time == 10) time = 5000;
						else time = time - 5;
					lcd_posstr("     ",1,10);
					ultoa(time,buf,10);
					lcd_posstr(buf,1,10);
				}
			};
			break;
		}
	};

	timer3_stop(); // zastaveni casovace
//	setb(LCD_PORT,LCD_LIGHT);
	return 0;

}



// =================================================================

// =================================================================
// ==================  Hlavni smycka =============================== 
// =================================================================
int main (void)
{

  asm volatile("CLI"); 	// disable all interrupts
 
  // SREG = 0x80;
  MCUCR = 0x00;
  // GICR  = 0x00;

  EICRB  = 0xFF; //external interrupts sources
  EIMSK = 0xF0;

  TIMSK = 0x04; //timer interrupt sources
  ETIMSK = 0x04; //extended timer interrupt sources

 // inicializace periferii procesoru   
  port_init();
  uart1_init();
  usart_baudrate(eeprom_read_byte(&eeprom_baud));
  timer1_init();
  hctl_init();
  lcd_init();

  //init_screen();
   
  asm volatile("SEI");	// re-enable interrupts

   _delay_ms(50);
   
  
  freez=0; //zmrazeni zobrazovani (diable)
  radix=10; //soustava zobrazovani (dec)
  usart=0; //poslilani na USART (diable)
  mode=1; //mode dekodovani 1x,2x,4x
  presc = 0; // preddelicka (disable)
  negx = 0;
  

  screen = 0;
  for(;;)    // nekonecna smycka 
  {
    
	switch (screen) // vybira zvolenou obrazovku s rezimem
	{
		case 0: // hlavni menu
		  	{
	  	    	screen = menu();;
		  	} 
    	break;  // *************

		case 1: // rezim couter
		  	{
      			 screen = counter();
			}
		break;
		 
		case 2: // rezim delka/rychlost
		  	{
      			 screen = velocity();
			} 
		break;  // *************

		case 3: // posilani do PC
		  	{
      			 screen = R232sending();
			} 
		break;  // *************
		 
		case 4: // menu-nastaveni
			{
      			screen = settings();
			}
		break;  // *************

		case 31: // menu-nastaveni-preddelicka
			{
      			screen = prescale(0);
			}
		break;  // *************

		case 32: // menu-nastaveni-tachometr
			{
      			screen = prescale(1);
			}
		break;  // *************

		case 33: // menu-nastaveni-tachometr
			{
      			screen = usart_settings();
			}
		break;  // *************

  	}
  }
 
}

// ================================================================
